SLASH_RELOADUI1 = "/rl" -- for quicker reloading
SlashCmdList.RELOADUI = ReloadUI


SLASH_UGGHYLOOT1 = "/UL2"
SLASH_UGGHYLOOT2 = "/ul2"
SLASH_UGGHYLOOT3 = "/Ul2"
SLASH_UGGHYLOOT4 = "/uL2"
function UL2_SlashHandler(msg)
	local validcommand = 0
	if (string.lower(msg)=="toggle") then
		EnableToggle()
		validcommand = 1
	end
	
	if (string.lower(msg)=="reset") then
		validcommand = 1 
		ResetAddon()
	end
	
	if (string.lower(msg)=="hide") then
		validcommand = 1
		HideUI()
	end
	if (string.lower(msg)=="show") then
	
		validcommand = 1
		ShowUI()
	end
	if (string.lower(msg)=="UL_debugon") then
	
		validcommand = 1
		UL_debug = true
	end
	if (string.lower(msg)=="UL_debugoff") then
	
		validcommand = 1
		UL_debug = false
	end
	if (string.lower(msg)=="about") then
	
		validcommand = 1
		print("UL2: UgghyLoot2 Loot Helper")
		print("UL2: Version:" .. UL_Version)
		print("UL2: (C) Ugghy-Zul'Jin")
		print("UL2: https://wow.curseforge.com/projects/ugghyloot2")
		print("UL2: Thanks to Orchasmez,Rustyoyo,Zues,Wizy,Monkeysea,TheUnc")
	end
	if validcommand == 0 then
		print("Usage: /ul2 toggle|show|hide|reset|about")
	end
end
SlashCmdList.UGGHYLOOT = UL2_SlashHandler
-------------------
---- VARIABLES ----
-------------------
UL_DB = {}

local UL_version = "1.1.0"
local UL_debug = false
local UL_Enabled = false
local UL_UIslotText = {}
local UL_UIslotSender = {}
local UL_UIslotState = {}
local UIConfig = CreateFrame("Frame","UgghyLoot2_Main",UIParent,"BasicFrameTemplateWithInset");
local UL_RollPattern = _G.RANDOM_ROLL_RESULT
	  UL_RollPattern = UL_RollPattern:gsub('%%s', '(.+)')
	  UL_RollPattern = UL_RollPattern:gsub('%%d %(%%d%-%%d%)', '(%%d+) %%((%%d+)%%-(%%d+)%%)')
	  UL_RollPattern = '^' .. UL_RollPattern .. '$'
local UL_itemBeingRolled = ""
local UL_Roller = {}
local UL_Roll = {}
local UL_NumRollers = 0
local UL_LootItems = 0
local UL_Rolloff = false
local UL_Funnies = {}
local UL_ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local UL_ldbIcon = LibStub:GetLibrary("LibDBIcon-1.0")
local UL_MMB = UL_ldb:NewDataObject("UgghyLoot2", 
		{ 
		type = "launcher",	
		icon = "Interface\\Addons\\UgghyLoot2\\UL2logo_red", 
		OnTooltipShow = function(tooltip)
			tooltip:SetText("UgghyLoot2 v"..UL_version)
			tooltip:AddLine("LMB - Show/Hide the Roll Panel",1,1,1)
			tooltip:AddLine("RMB - Toggle Listen Mode",1,1,1)
			tooltip:AddLine("Ctrl-LMB - Roll on next item",1,1,1)
			tooltip:AddLine("Ctrl-Shift-LMB - Reset all data",1,1,1)
			tooltip:Show()
		end, 
		OnClick = function(clickedframe,button)
			local button = GetMouseButtonClicked()
			local shiftDown = IsShiftKeyDown()
			local ctrlDown  = IsControlKeyDown()
			local altDown   = IsAltKeyDown()
			local UL2_MMBClick = ""
			if shiftDown then UL2_MMBClick = UL2_MMBClick .. "Shift-" end
			if ctrlDown then UL2_MMBClick = UL2_MMBClick .. "Ctrl-" end
			if altDown then UL2_MMBClick = UL2_MMBClick .. "Alt-" end
			UL2_MMBClick = UL2_MMBClick .. tostring(button)
			-- DEFAULT_CHAT_FRAME:AddMessage(UL2_MMBClick .. " was clicked.")
			if UL2_MMBClick == "RightButton" then
				EnableToggle()
			end
			if UL2_MMBClick == "LeftButton" then
				if UIConfig:IsVisible() then 
					HideUI()
				else
					ShowUI()
				end
			end
			if UL2_MMBClick == "Ctrl-LeftButton" then
				if UL_LootItems > 0 then
					ListenForRolls(1)
				else
					print("UL2:No items to roll on")
				end
			end
			if UL2_MMBClick == "Shift-Ctrl-LeftButton" then
				ResetAddon()
			end
		end
	})


-------------------
---- Functions ----
-------------------
function ResetAddon()
	UL_Enabled = false
	UL_itemBeingRolled = ""
	UL_Roller = {}
	UL_Roll = {}
	UL_NumRollers = 0
	UL_Rolloff = false
	UL_UIslotText = {}
	UL_UIslotSender = {}
	UL_UIslotState = {}
	UL_LootItems = 0
	UL_debug = false
	
	SetInitialState()
	UpdateSlots()
	print("UL2:Addon reset")
end
function SetListenScript()
	UIConfig:SetScript("OnEvent", function(self, event, msg, sender, ...)
			if (event == "CHAT_MSG_WHISPER" ) then
				WhisperReceivedEvent(event,msg,sender,...)
			end
			if (event == "CHAT_MSG_SYSTEM") then
				if UL_debug then print("UL2:OnEvent:SIS: Got info - " .. event .. " - " .. msg .. " - " .. sender .. " - " .. ...) end
				if UL_debug then print (event,msg,sender,...) end
				if UL_Rolloff then 
					if UL_debug then print("UL2:RolloffRolls") end
					NewRollOffRoll(event,msg,...)
				else
					if UL_debug then print("UL2:Regular Rolls") end
					NewStoreRoll(event,msg, ...)
				end
				
			end
		end
	)
end
function SetRollState(slot,state)
	if state == 1 then -- we are rolling on loot, set all the other buttons off
		
		if slot == 1 then UIConfig.rollBtn1:SetText("Rolling") end
		if slot == 2 then UIConfig.rollBtn2:SetText("Rolling") end
		if slot == 3 then UIConfig.rollBtn3:SetText("Rolling") end
		if slot == 4 then UIConfig.rollBtn4:SetText("Rolling") end
		if slot == 5 then UIConfig.rollBtn5:SetText("Rolling") end
		if slot == 6 then UIConfig.rollBtn6:SetText("Rolling") end
		if slot == 7 then UIConfig.rollBtn7:SetText("Rolling") end
		if slot == 8 then UIConfig.rollBtn8:SetText("Rolling") end
		UIConfig.clrBtn1:Disable()
		UIConfig.rollBtn1:Disable()
		UIConfig.clrBtn2:Disable()
		UIConfig.rollBtn2:Disable()
		UIConfig.clrBtn3:Disable()
		UIConfig.rollBtn3:Disable()
		UIConfig.clrBtn4:Disable()
		UIConfig.rollBtn4:Disable()
		UIConfig.clrBtn5:Disable()
		UIConfig.rollBtn5:Disable()
		UIConfig.clrBtn6:Disable()
		UIConfig.rollBtn6:Disable()
		UIConfig.clrBtn7:Disable()
		UIConfig.rollBtn7:Disable()
		UIConfig.clrBtn8:Disable()
		UIConfig.rollBtn8:Disable()
	end
	if state == 0 then -- we are NOT rolling on loot, set all the buttons on
		
		if slot == 1 then UIConfig.rollBtn1:SetText("Roll") end
		if slot == 2 then UIConfig.rollBtn2:SetText("Roll") end
		if slot == 3 then UIConfig.rollBtn3:SetText("Roll") end
		if slot == 4 then UIConfig.rollBtn4:SetText("Roll") end
		if slot == 5 then UIConfig.rollBtn5:SetText("Roll") end
		if slot == 6 then UIConfig.rollBtn6:SetText("Roll") end
		if slot == 7 then UIConfig.rollBtn7:SetText("Roll") end
		if slot == 8 then UIConfig.rollBtn8:SetText("Roll") end
		UIConfig.clrBtn1:Enable()
		UIConfig.rollBtn1:Enable()
		UIConfig.clrBtn2:Enable()
		UIConfig.rollBtn2:Enable()
		UIConfig.clrBtn3:Enable()
		UIConfig.rollBtn3:Enable()
		UIConfig.clrBtn4:Enable()
		UIConfig.rollBtn4:Enable()
		UIConfig.clrBtn5:Enable()
		UIConfig.rollBtn5:Enable()
		UIConfig.clrBtn6:Enable()
		UIConfig.rollBtn6:Enable()
		UIConfig.clrBtn7:Enable()
		UIConfig.rollBtn7:Enable()
		UIConfig.clrBtn8:Enable()
		UIConfig.rollBtn8:Enable()
	end
end
function ListenForRolls(slot)
	-- Monitor the chat for Rolls
		SetRollState(slot,1)
		if UL_debug then print("UL2:In ListenForRolls") end
		UL_itemBeingRolled = UL_UIslotText[slot]
		if UL_debug then print("UL2:item Being Rolled For : " .. UL_itemBeingRolled) end
		SendChatMessage("UL2: Roll for " .. UL_itemBeingRolled, "RAID_WARNING")
		SendChatMessage("UL2: -- You have 20 seconds --" , "RAID_WARNING")
		UIConfig:RegisterEvent("CHAT_MSG_SYSTEM")
		if UL_debug then print("UL2: Listening for rolls...") end
		C_Timer.After(10, function()
			HalfTime(5,UL_itemBeingRolled,slot)
			end
		)
		if UL_debug then print("We came back to ListenForRolls") end
		
end
function HalfTime(duration,item,slot)
	SendChatMessage("UL2: Rolling for " .. item , "RAID_WARNING")
	SendChatMessage("UL2: -- You have " .. duration + 5 .. " seconds remaining --", "RAID_WARNING")
	C_Timer.After(duration, function()
		UL_Countdown = 5
		LastFive(UL_Countdown,item,slot)
		end
	)
end
function LastFive(duration,item,slot)
	if UL_Countdown > 4 then 
		SendChatMessage("UL2: Rolling for " .. item , "RAID_WARNING")
		SendChatMessage("UL2: -- You have " .. UL_Countdown .. " seconds remaining --", "RAID_WARNING")
	else 
		SendChatMessage("UL2: -" .. UL_Countdown .. "-", "RAID")
	end
	
	if (UL_Countdown > 0) then
		C_Timer.After(1, function()
			UL_Countdown = UL_Countdown - 1
			LastFive(1,item,slot)
			end
		)
	else
		
		if UL_debug then print("endListen") end
		EndListenForRolls(item,slot)
		 
	end
end
function NewStoreRoll(event,msg, ...)
	if UL_debug then print("UL2: Caught a roll" .. msg) end
	-- Capture a Roll event
	-- Determine if the roll is valid
	-- register valid rolls
	-- respond to roller
	-- ignore duplicates/invalid ranges
	-- update Roll Frame
	if msg then
		local name, roll, minRoll, maxRoll = msg:match('^(.+) rolls (%d+) %((%d+)%-(%d+)%)$')
		--local name, roll, minRoll, maxRoll = msg:match(UL_RollPattern)
		if (name) and (roll) then
			-- check for duplicate roll
			duplicaterollflag = 0
			if UL_NumRollers > 0 then
				for i = 1,UL_NumRollers, 1 do							
					if UL_Roller[i] == name then
						duplicaterollflag = 1
					end
				end
				if duplicaterollflag == 1 then
					-- this is a duplicate, ignore it
					if UL_debug then print(name .. " rolled more than once") end
					
					SendChatMessage("UL2:" .. name ..", " .. UL_Funnies[ math.random(#UL_Funnies)],"RAID")
					SendWhisper("UL2: Sorry, you can only roll once!", name)
					name = nil
				end
			end
			-- check for invalid roll
			if minRoll ~= '1' or maxRoll ~= '100' then
				if UL_debug then print(name .. " roll was invalid ") end
				
				SendWhisper("UL2:You must roll 1-100. Your roll was ignored",name)
				name = nil
			end	
		end
		if (name) and (roll) then 
			UL_NumRollers = UL_NumRollers + 1
			if UL_debug then print("UL2:UL_NumRollers=" .. UL_NumRollers) end
			UL_Roller[UL_NumRollers] = name
			if UL_debug then print("UL2:UL_Roller(num) = " .. UL_Roller[UL_NumRollers]) end
			UL_Roll[UL_NumRollers] = roll
			if UL_debug then print(UL_Roller[UL_NumRollers] .. " rolled a " .. UL_Roll[UL_NumRollers]) end
			SendWhisper(" Thanks, your roll of " .. roll .. " was received.", name)
		else
			if UL_debug then print("UL2:not a roll event") end
		end
	end	 
end
function NewRollOffRoll(event,msg, ...)
	
	if UL_debug then print("UL2:Caught a rolloff roll") end
	-- we can run the rolls again, but limit the rollers to the ones in Winners
	if msg then
		local name, roll, minRoll, maxRoll = msg:match('^(.+) rolls (%d+) %((%d+)%-(%d+)%)$')
		--local name, roll, minRoll, maxRoll = msg:match(UL_RollPattern)
		-- check for duplicate roll
		if UL_debug then print("UL2:Check Rolloff Roller is valid") end
		validrolloffflag = 0
		for i = 1,Winners,1 do
			if UL_debug then print("UL2:Roller:" .. name .. "Winner[" .. i .. "]" .. Winner[i]) end
			if Winner[i] == name then 
				validrolloffflag = 1
				if UL_debug then print("UL2:Valid = " .. validrolloffflag) end
				break				
			end
		end
		if validrolloffflag == 1 then
			if UL_debug then print("UL2:RollOff:Check for Dupe") end
			duplicaterollflag = 0
			if UL_NumRollers > 0 then
				if UL_debug then print("UL2:RollOff:DupeCheck") end
				for i = 1,UL_NumRollers, 1 do
					if UL_Roller[i] == name then
						duplicaterollflag = 1
						if UL_debug then print("UL2:RollOff:Dupe Found") end
					end
				end
				if duplicaterollflag == 1 then
					-- this is a duplicate, ignore it
					if UL_debug then print(name .. " rolled more than once") end
					
					SendChatMessage("UL2:" .. name .. "," ..UL_Funnies[ math.random(#UL_Funnies)],"RAID")
					SendWhisper("UL2: Sorry, you can only roll once!", name)
					name = nil
				end
			end	
			if UL_debug then print("UL2:RollOff:Dupe Check Done") end
			-- check for invalid roll
			if minRoll ~= '1' or maxRoll ~= '100' then
				if UL_debug then print(name .. " roll was invalid ") end
				
				SendWhisper("You must roll 1-100. Your roll was ignored",name)
				name = nil
			end	
			if UL_debug then print("UL2:Rolloff:Name:" .. name .. " Roll:" .. roll) end
			if (name) and (roll) then 
				UL_NumRollers = UL_NumRollers + 1
				if UL_debug then print("UL2:RollOff:UL_NumRollers=" .. UL_NumRollers) end
				UL_Roller[UL_NumRollers] = name
				if UL_debug then print("UL2:RollOff:UL_Roller(num) = " .. UL_Roller[UL_NumRollers]) end
				UL_Roll[UL_NumRollers] = roll
				if UL_debug then print(UL_Roller[UL_NumRollers] .. " rolled a " .. UL_Roll[UL_NumRollers]) end
				SendWhisper("UL2: Thanks, your rolloff roll of " .. roll .. " was received.", name)
			else
				if UL_debug then print("UL2:not a roll event") end
			end
		end
	else
		if UL_debug then print("UL2:Rolloff:Not Valid Roller Flagged") end
	end	
end
function EndListenForRolls(item,slot)
	-- Stop Monitoring the Chat for Rolls
		UIConfig:UnregisterEvent("CHAT_MSG_SYSTEM")
	-- Announce end of Rolling
		SendChatMessage("UL2: Rolls finished for " .. item , "RAID_WARNING")
		-- SendChatMessage("UL2: " .. UL_NumRollers .. " rolls captured. ", "RAID")
	-- Determine Winner
		DetermineWinner(item,slot)
		
end
function BubbleSort(array,array2,arraylen)
	
	return array
end
function DetermineWinner(item,slot)
	-- Sort rolls by Highest -> Lowest
		if UL_debug then print("Start Determine Winner") end
		if UL_NumRollers == 0 then
			--We have no rollers, skip the rest of the routine and announce no takers.
			SendChatMessage("UL2: No rolls detected.", "RAID_WARNING")
			SetRollState(slot,0)
			if UL_LootItems > 1 then 
				SendChatMessage("UL2: " .. UL_LootItems .. " loot items remaining to be rolled on.", "RAID")
			end
			if UL_LootItems == 1 then 
				SendChatMessage("UL2: " .. UL_LootItems .. " loot item remaining to be rolled on.", "RAID")
			end
			if UL_LootItems == 0 then 
				SendChatMessage("UL2: Loot Rolling complete. No remaining items.", "RAID")
			end
		else
			for UL_Rolls = 1,UL_NumRollers,1 do
				if UL_debug then print(UL_Roller[UL_Rolls] .. " - " .. UL_Roll[UL_Rolls]) end
			end
			-- find the highest roller
			local i = 1
			local j = 1
			local temp2
			for i = 1,UL_NumRollers+1,1 do
			for j = UL_NumRollers,i+1,-1 do
				if UL_debug then print("i:" .. i .. " j:" .. j) end
				if (tonumber(UL_Roll[j]) < tonumber(UL_Roll[j-1])) then
					temp = UL_Roll[j]
					UL_Roll[j] = UL_Roll[j-1]
					UL_Roll[j-1] = temp
					temp2 = UL_Roller[j]
					UL_Roller[j] = UL_Roller[j-1]
					UL_Roller[j-1] = temp2
					
				end
				if UL_debug then print("Done inner Loop") end
			end
		end
			for i = 1, UL_NumRollers, 1 do
			if UL_debug then print("Roller:" .. UL_Roller[i] .. " - " .. UL_Roll[i]) end
		end
			local temprolls = {}
			local temprollers = {}
			for i = 1, UL_NumRollers, 1 do
			temprolls[i] = UL_Roll[UL_NumRollers + 1 - i]
			temprollers[i] = UL_Roller[UL_NumRollers + 1 - i]
		end
			for i = 1, UL_NumRollers, 1 do
			UL_Roll[i] = temprolls[i]
			UL_Roller[i] = temprollers[i]
			
		end
			SendChatMessage("UL2: ---ROLL RESULTS---", "RAID")
			for i = 1, UL_NumRollers, 1 do
			SendChatMessage("UL2: " .. UL_Roller[i] .. " rolled a " .. UL_Roll[i], "RAID")
		end
			SendChatMessage("UL2: ------------------", "RAID")
			CheckforTie(item,slot)
		end
end
function CheckforTie(item,slot)
	if UL_debug then print("UL2: In CheckforTie") end
	-- two things to do. If we have tied rolls at the top of the table, we have to do a roll off.
	-- first, check to see if we have a tie
	Winner = {}
	WinnerRoll = {}
	Winners = 1
	Winner[Winners] = UL_Roller[1]
	WinnerRoll[Winners] = UL_Roll[1]
	TiedMessage = ""
	if UL_NumRollers > 1 then 
		for i = 2,UL_NumRollers, 1 do
			if UL_Roll[1] == UL_Roll[i] then
				-- The top roll is tied - add the tied name to the winners list
				Winners = Winners + 1
				Winner[Winners] = UL_Roller[i]
				WinnerRoll[Winners] = UL_Roll[i]
				if UL_debug then print("UL2:Added the dupe to the list : " .. Winner[Winners]) end
			end
		end
	end
	-- if we have more than one winner - ask them to roll off
		
	if Winners > 1 then 
		SendChatMessage("UL2: " .. Winners .. " Winners tied for " .. item , "RAID_WARNING")
		for j = 1,Winners,1 do
			TiedMessage = TiedMessage .. Winner[j] .. ","
		end
		SendChatMessage("UL2: " .. TiedMessage .. " please roll again. ", "RAID_WARNING")
		ListenForTieBreaker(item,slot)
	else
		AnnounceWinner(item,slot)
	end
end
function ListenForTieBreaker(item,slot)
	if UL_debug then print("UL2:In ListenForTieBreaker") end
	-- message the tied individuals and have them roll again
	for i = 1,Winners, 1 do
		SendWhisper("You are tied. Please roll again", Winner[i])
	end
	for j = 1, UL_NumRollers,1 do
		UL_Roll[j] = nil
		UL_Roller[j] = ""
	end
	UL_NumRollers = 0
	UL_Countdown = 10
	UL_Rolloff = true
	UIConfig:RegisterEvent("CHAT_MSG_SYSTEM") -- Listen for rolls
	-- start a RollOffTimer
	
	RollOffCountdown(1,item,slot)
	
end
function RollOffCountdown(duration,item,slot)
	
	if UL_Countdown > 9 then 
		SendChatMessage("UL2: Roll off for " .. item , "RAID_WARNING")
		SendChatMessage("UL2: -- You have " .. UL_Countdown .. " seconds remaining --", "RAID_WARNING")
	else 
		SendChatMessage("UL2: -" .. UL_Countdown .. "-", "RAID")
	end
	
	if (UL_Countdown > 0) then
		C_Timer.After(1, function()
			UL_Countdown = UL_Countdown - 1
			RollOffCountdown(1,item,slot)
			end
		)
	else
		
		if UL_debug then print("UL2:endRolloffListen") end
		UIConfig:UnregisterEvent("CHAT_MSG_SYSTEM") -- Stop listening for rolls
		UL_Rolloff = false
		DetermineWinner(item,slot) 
	end
end
function AnnounceWinner(item,slot)
		if UL_debug then print("UL2:In AnnounceWinner") end
	   SetRollState(slot,0)
	-- Announce Winner to Raid
		SendChatMessage("UL2:" .. Winner[1] .. " is the winner of " .. item, "RAID_WARNING")
		SendDelayedWhisper(2,"You have won! Collect " .. item .. " from " .. UL_UIslotSender[slot], Winner[1])
		SendDelayedWhisper(2, Winner[1] .. " won your " .. item .. ", they will come to collect.", UL_UIslotSender[slot])
		-- UL_itemBeingRolled = ""
		UL_Roller = {}
		UL_Roll = {}
		UL_NumRollers = 0
		UL_Rolloff = false
		--Mark Loot Slot as completed
		-- Write a log of the winner and item
		RemoveLoot(slot)
		
end
function SetInitialState()
	local UL_UIloop = 1
	for UL_UIloop = 1,8,1 do 
		UL_UIslotText[UL_UIloop] = ""
		UL_UIslotState[UL_UIloop] = 0
		UL_UIslotSender[UL_UIloop] = ""
	end
	if UL_Enabled == true then 
		UIConfig:RegisterEvent("CHAT_MSG_WHISPER", "WhisperReceivedEvent") 
		SetListenScript()
	end
	UL_Funnies[1] = "Rolling more than once is naughty."
	UL_Funnies[2] = "Is that you Clementt?"
	UL_Funnies[3] = "You can't roll twice. YORO...seriously.."
	UL_Funnies[4] = "I get that it's pretty, but you only get to roll once !"
	UL_Funnies[5] = "Give me a roll Vasilly...ONE ROLL ONLY!"
	UL_Funnies[6] = "Rolling twice ? -200 DKP !!"
	UL_Funnies[7] = "Sheesh, I get that loot is rare..but you don't get to double roll !"
	UL_Funnies[8] = "No. No NO! No double rolls ! Go stand in the fire..."
	UL_Funnies[9] = "Double-rolling does not get you a haste buff..."
	UL_Funnies[10] = "First impressions count. Second rolls don't."
	UL_Funnies[11] = "If only we could add your two rolls together...BUT WE CAN'T!"
end
function SetUIText(slot, text)
		if slot == 1 then UIConfig.TextBox1:SetText(text) end
		if slot == 2 then UIConfig.TextBox2:SetText(text) end
		if slot == 3 then UIConfig.TextBox3:SetText(text) end
		if slot == 4 then UIConfig.TextBox4:SetText(text) end
		if slot == 5 then UIConfig.TextBox5:SetText(text) end
		if slot == 6 then UIConfig.TextBox6:SetText(text) end
		if slot == 7 then UIConfig.TextBox7:SetText(text) end
		if slot == 8 then UIConfig.TextBox8:SetText(text) end
end
function UpdateSlots()
	local activeSlot = 1
	for UL_UIloop = 1,8,1 do 
			SetUIText(activeSlot,UL_UIslotText[UL_UIloop])
			SetUISlotActive(activeSlot,UL_UIslotState[UL_UIloop])
			
			activeSlot = activeSlot + 1
		
	end
end
function SetUISlotActive(slot,state)
-- Set the visibility of a slot
	
	if state == 0 then
		
		if slot == 1 then
			UIConfig.TextBox1:Hide()
			UIConfig.rollBtn1:Hide()
			UIConfig.clrBtn1:Hide()
		end
		if slot == 2 then
			UIConfig.TextBox2:Hide()
			UIConfig.rollBtn2:Hide()
			UIConfig.clrBtn2:Hide()
		end
		if slot == 3 then
			UIConfig.TextBox3:Hide()
			UIConfig.rollBtn3:Hide()
			UIConfig.clrBtn3:Hide()
		end
		if slot == 4 then
			UIConfig.TextBox4:Hide()
			UIConfig.rollBtn4:Hide()
			UIConfig.clrBtn4:Hide()
		end
		if slot == 5 then
			UIConfig.TextBox5:Hide()
			UIConfig.rollBtn5:Hide()
			UIConfig.clrBtn5:Hide()
		end
		if slot == 6 then
			UIConfig.TextBox6:Hide()
			UIConfig.rollBtn6:Hide()
			UIConfig.clrBtn6:Hide()
		end
		if slot == 7 then
			UIConfig.TextBox7:Hide()
			UIConfig.rollBtn7:Hide()
			UIConfig.clrBtn7:Hide()
		end
		if slot == 8 then
			UIConfig.TextBox8:Hide()
			UIConfig.rollBtn8:Hide()
			UIConfig.clrBtn8:Hide()
		end
	end
	if state == 1 then
		
		if slot == 1 then
			UIConfig.TextBox1:Show()
			UIConfig.rollBtn1:Show()
			UIConfig.clrBtn1:Show()
		end
		if slot == 2 then
			UIConfig.TextBox2:Show()
			UIConfig.rollBtn2:Show()
			UIConfig.clrBtn2:Show()
		end
		if slot == 3 then
			UIConfig.TextBox3:Show()
			UIConfig.rollBtn3:Show()
			UIConfig.clrBtn3:Show()
		end
		if slot == 4 then
			UIConfig.TextBox4:Show()
			UIConfig.rollBtn4:Show()
			UIConfig.clrBtn4:Show()
		end
		if slot == 5 then
			UIConfig.TextBox5:Show()
			UIConfig.rollBtn5:Show()
			UIConfig.clrBtn5:Show()
		end
		if slot == 6 then
			UIConfig.TextBox6:Show()
			UIConfig.rollBtn6:Show()
			UIConfig.clrBtn6:Show()
		end
		if slot == 7 then
			UIConfig.TextBox7:Show()
			UIConfig.rollBtn7:Show()
			UIConfig.clrBtn7:Show()
		end
		if slot == 8 then
			UIConfig.TextBox8:Show()
			UIConfig.rollBtn8:Show()
			UIConfig.clrBtn8:Show()
		end
	end
end
function SetUI(self)	

	UIConfig:SetSize(400,400); -- Width, Height
	UIConfig:SetMovable(true)
	UIConfig:EnableMouse(true)
	UIConfig:RegisterForDrag("LeftButton")
	UIConfig:SetScript("OnDragStart", UIConfig.StartMoving)
	UIConfig:SetScript("OnDragStop", UIConfig.StopMovingOrSizing)
	UIConfig:SetPoint("CENTER",UIParent,"CENTER"); -- point, relativeframe, relativepoint, xOffset, yOffset
	UIConfig.Title = UIConfig:CreateFontString(nil, "OVERLAY");
	UIConfig.Title:SetFontObject("GameFontHighlight");
	UIConfig.Title:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, 0);
	UIConfig.Title:SetText("Ugghy Loot 2");
-- Roll Block 1
	UIConfig.TextBox1 = UIConfig:CreateFontString(nil, "OVERLAY");
	UIConfig.TextBox1:SetFontObject("GameFontHighlight");
	UIConfig.TextBox1:SetPoint("TOPLEFT", UIConfig.Bg, "TOPLEFT", 10, -20);
	UIConfig.TextBox1:SetText(UL_UIslotText[1]);
	
	
	
	UIConfig.clrBtn1 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.clrBtn1:SetPoint("TOPRIGHT",UIConfig.Bg,"TOPRIGHT", -20, -20);
	UIConfig.clrBtn1:SetSize(40,20);
	UIConfig.clrBtn1:SetText("Clear");
	UIConfig.clrBtn1:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.clrBtn1:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.clrBtn1:SetScript("OnClick",function(self)
		RemoveLoot(1)
		end)
	UIConfig.rollBtn1 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.rollBtn1:SetPoint("LEFT",UIConfig.clrBtn1,"LEFT", -50, 0);
	UIConfig.rollBtn1:SetSize(40,20);
	UIConfig.rollBtn1:SetText("Roll");
	UIConfig.rollBtn1:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.rollBtn1:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.rollBtn1:SetScript("OnClick",function(self,arg1)
		print("UL2: Starting Listen")
		ListenForRolls(1)
		end)
	UIConfig.rollBtn1:SetScript("OnEnter",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn1,"ANCHOR_CURSOR")
		if UL_UIslotText[1] ~= nil then UIConfig.tip:SetHyperlink(UL_UIslotText[1]) end
		UIConfig.tip:Show()
		end)
	UIConfig.rollBtn1:SetScript("OnLeave",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn1,"ANCHOR_CURSOR")
		UIConfig.tip:Hide()
		end)
	-- Roll Block 2
	UIConfig.TextBox2 = UIConfig:CreateFontString(nil, "OVERLAY");
	UIConfig.TextBox2:SetFontObject("GameFontHighlight");
	UIConfig.TextBox2:SetPoint("TOPLEFT", UIConfig.Bg, "TOPLEFT", 10, -40);
	UIConfig.clrBtn2 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.clrBtn2:SetPoint("TOPRIGHT",UIConfig.Bg,"TOPRIGHT", -20, -40);
	UIConfig.clrBtn2:SetSize(40,20);
	UIConfig.clrBtn2:SetText("Clear");
	UIConfig.clrBtn2:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.clrBtn2:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.clrBtn2:SetScript("OnClick",function(self)
		RemoveLoot(2)
		end)
	UIConfig.rollBtn2 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.rollBtn2:SetPoint("LEFT",UIConfig.clrBtn2,"LEFT", -50, 0);
	UIConfig.rollBtn2:SetSize(40,20);
	UIConfig.rollBtn2:SetText("Roll");
	UIConfig.rollBtn2:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.rollBtn2:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.rollBtn2:SetScript("OnClick",function(self,arg1)
		print("UL2: Starting Listen")
		ListenForRolls(2)
		end)
	UIConfig.rollBtn2:SetScript("OnEnter",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn2,"ANCHOR_CURSOR")
		if UL_UIslotText[2] ~= nil then UIConfig.tip:SetHyperlink(UL_UIslotText[2]) end
		UIConfig.tip:Show()
		end)
	UIConfig.rollBtn2:SetScript("OnLeave",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn1,"ANCHOR_CURSOR")
		UIConfig.tip:Hide()
		end)
	-- Roll Block 3
	UIConfig.TextBox3 = UIConfig:CreateFontString(nil, "OVERLAY");
	UIConfig.TextBox3:SetFontObject("GameFontHighlight");
	UIConfig.TextBox3:SetPoint("TOPLEFT", UIConfig.Bg, "TOPLEFT", 10, -60);
	UIConfig.clrBtn3 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.clrBtn3:SetPoint("TOPRIGHT",UIConfig.Bg,"TOPRIGHT", -20, -60);
	UIConfig.clrBtn3:SetSize(40,20);
	UIConfig.clrBtn3:SetText("Clear");
	UIConfig.clrBtn3:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.clrBtn3:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.clrBtn3:SetScript("OnClick",function(self)
		RemoveLoot(3)
		end)
	UIConfig.rollBtn3 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.rollBtn3:SetPoint("LEFT",UIConfig.clrBtn3,"LEFT", -50, 0);
	UIConfig.rollBtn3:SetSize(40,20);
	UIConfig.rollBtn3:SetText("Roll");
	UIConfig.rollBtn3:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.rollBtn3:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.rollBtn3:SetScript("OnClick",function(self,arg1)
		print("UL2: Starting Listen")
		ListenForRolls(3)
		end)
	UIConfig.rollBtn3:SetScript("OnEnter",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn3,"ANCHOR_CURSOR")
		if UL_UIslotText[3] ~= nil then UIConfig.tip:SetHyperlink(UL_UIslotText[3]) end
		UIConfig.tip:Show()
		end)
	UIConfig.rollBtn3:SetScript("OnLeave",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn1,"ANCHOR_CURSOR")
		UIConfig.tip:Hide()
		end)
	-- Roll Block 4
	UIConfig.TextBox4 = UIConfig:CreateFontString(nil, "OVERLAY");
	UIConfig.TextBox4:SetFontObject("GameFontHighlight");
	UIConfig.TextBox4:SetPoint("TOPLEFT", UIConfig.Bg, "TOPLEFT", 10, -80);
	UIConfig.clrBtn4 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.clrBtn4:SetPoint("TOPRIGHT",UIConfig.Bg,"TOPRIGHT", -20, -80);
	UIConfig.clrBtn4:SetSize(40,20);
	UIConfig.clrBtn4:SetText("Clear");
	UIConfig.clrBtn4:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.clrBtn4:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.clrBtn4:SetScript("OnClick",function(self)
		RemoveLoot(4)
		end)
	UIConfig.rollBtn4 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.rollBtn4:SetPoint("LEFT",UIConfig.clrBtn4,"LEFT", -50, 0);
	UIConfig.rollBtn4:SetSize(40,20);
	UIConfig.rollBtn4:SetText("Roll");
	UIConfig.rollBtn4:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.rollBtn4:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.rollBtn4:SetScript("OnClick",function(self,arg1)
		print("UL2: Starting Listen")
		ListenForRolls(4)
		end)
	UIConfig.rollBtn4:SetScript("OnEnter",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn4,"ANCHOR_CURSOR")
		if UL_UIslotText[4] ~= nil then UIConfig.tip:SetHyperlink(UL_UIslotText[4]) end
		UIConfig.tip:Show()
		end)
	UIConfig.rollBtn4:SetScript("OnLeave",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn1,"ANCHOR_CURSOR")
		UIConfig.tip:Hide()
		end)
	-- Roll Block 5
	UIConfig.TextBox5 = UIConfig:CreateFontString(nil, "OVERLAY");
	UIConfig.TextBox5:SetFontObject("GameFontHighlight");
	UIConfig.TextBox5:SetPoint("TOPLEFT", UIConfig.Bg, "TOPLEFT", 10, -100);
	UIConfig.clrBtn5 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.clrBtn5:SetPoint("TOPRIGHT",UIConfig.Bg,"TOPRIGHT", -20, -100);
	UIConfig.clrBtn5:SetSize(40,20);
	UIConfig.clrBtn5:SetText("Clear");
	UIConfig.clrBtn5:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.clrBtn5:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.clrBtn5:SetScript("OnClick",function(self)
		RemoveLoot(5)
		end)
	UIConfig.rollBtn5 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.rollBtn5:SetPoint("LEFT",UIConfig.clrBtn5,"LEFT", -50, 0);
	UIConfig.rollBtn5:SetSize(40,20);
	UIConfig.rollBtn5:SetText("Roll");
	UIConfig.rollBtn5:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.rollBtn5:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.rollBtn5:SetScript("OnClick",function(self,arg1)
		print("UL2: Starting Listen")
		ListenForRolls(5)
		end)
	UIConfig.rollBtn5:SetScript("OnEnter",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn5,"ANCHOR_CURSOR")
		if UL_UIslotText[5] ~= nil then UIConfig.tip:SetHyperlink(UL_UIslotText[5]) end
		UIConfig.tip:Show()
		end)
	UIConfig.rollBtn5:SetScript("OnLeave",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn1,"ANCHOR_CURSOR")
		UIConfig.tip:Hide()
		end)
	-- Roll Block 6
	UIConfig.TextBox6 = UIConfig:CreateFontString(nil, "OVERLAY");
	UIConfig.TextBox6:SetFontObject("GameFontHighlight");
	UIConfig.TextBox6:SetPoint("TOPLEFT", UIConfig.Bg, "TOPLEFT", 10, -120);
	UIConfig.clrBtn6 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.clrBtn6:SetPoint("TOPRIGHT",UIConfig.Bg,"TOPRIGHT", -20, -120);
	UIConfig.clrBtn6:SetSize(40,20);
	UIConfig.clrBtn6:SetText("Clear");
	UIConfig.clrBtn6:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.clrBtn6:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.clrBtn6:SetScript("OnClick",function(self)
		RemoveLoot(6)
		end)
	UIConfig.rollBtn6 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.rollBtn6:SetPoint("LEFT",UIConfig.clrBtn6,"LEFT", -50, 0);
	UIConfig.rollBtn6:SetSize(40,20);
	UIConfig.rollBtn6:SetText("Roll");
	UIConfig.rollBtn6:SetNormalFontObject("GameFontNormalLarge");
		UIConfig.rollBtn6:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.rollBtn6:SetScript("OnClick",function(self,arg1)
		print("UL2: Starting Listen")
		ListenForRolls(6)
		end)
	UIConfig.rollBtn6:SetScript("OnEnter",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn6,"ANCHOR_CURSOR")
		if UL_UIslotText[6] ~= nil then UIConfig.tip:SetHyperlink(UL_UIslotText[6]) end
		UIConfig.tip:Show()
		end)
	UIConfig.rollBtn6:SetScript("OnLeave",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn1,"ANCHOR_CURSOR")
		UIConfig.tip:Hide()
		end)
	-- Roll Block 7
	UIConfig.TextBox7 = UIConfig:CreateFontString(nil, "OVERLAY");
	UIConfig.TextBox7:SetFontObject("GameFontHighlight");
	UIConfig.TextBox7:SetPoint("TOPLEFT", UIConfig.Bg, "TOPLEFT", 10, -140);
	UIConfig.clrBtn7 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.clrBtn7:SetPoint("TOPRIGHT",UIConfig.Bg,"TOPRIGHT", -20, -140);
	UIConfig.clrBtn7:SetSize(40,20);
	UIConfig.clrBtn7:SetText("Clear");
	UIConfig.clrBtn7:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.clrBtn7:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.clrBtn7:SetScript("OnClick",function(self)
		RemoveLoot(7)
		end)
	UIConfig.rollBtn7 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.rollBtn7:SetPoint("LEFT",UIConfig.clrBtn7,"LEFT", -50, 0);
	UIConfig.rollBtn7:SetSize(40,20);
	UIConfig.rollBtn7:SetText("Roll");
	UIConfig.rollBtn7:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.rollBtn7:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.rollBtn7:SetScript("OnClick",function(self,arg1)
		print("UL2: Starting Listen")
		ListenForRolls(7)
		end)
	UIConfig.rollBtn7:SetScript("OnEnter",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn7,"ANCHOR_CURSOR")
		if UL_UIslotText[7] ~= nil then UIConfig.tip:SetHyperlink(UL_UIslotText[7]) end
		UIConfig.tip:Show()
		end)
	UIConfig.rollBtn7:SetScript("OnLeave",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn1,"ANCHOR_CURSOR")
		UIConfig.tip:Hide()
		end)
	-- Roll Block 8
	UIConfig.TextBox8 = UIConfig:CreateFontString(nil, "OVERLAY");
	UIConfig.TextBox8:SetFontObject("GameFontHighlight");
	UIConfig.TextBox8:SetPoint("TOPLEFT", UIConfig.Bg, "TOPLEFT", 10, -160);
	UIConfig.clrBtn8 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.clrBtn8:SetPoint("TOPRIGHT",UIConfig.Bg,"TOPRIGHT", -20, -160);
	UIConfig.clrBtn8:SetSize(40,20);
	UIConfig.clrBtn8:SetText("Clear");
	UIConfig.clrBtn8:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.clrBtn8:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.clrBtn8:SetScript("OnClick",function(self)
		RemoveLoot(8)
		end)
	UIConfig.rollBtn8 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.rollBtn8:SetPoint("LEFT",UIConfig.clrBtn8,"LEFT", -50, 0);
	UIConfig.rollBtn8:SetSize(40,20);
	UIConfig.rollBtn8:SetText("Roll");
	UIConfig.rollBtn8:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.rollBtn8:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.rollBtn8:SetScript("OnClick",function(self,arg1)
		print("UL2: Starting Listen")
		ListenForRolls(8)
		end)
	UIConfig.rollBtn8:SetScript("OnEnter",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn8,"ANCHOR_CURSOR")
		if UL_UIslotText[8] ~= nil then UIConfig.tip:SetHyperlink(UL_UIslotText[8]) end
		UIConfig.tip:Show()
		end)
	UIConfig.rollBtn8:SetScript("OnLeave",function(self,motion)
		UIConfig.tip:SetOwner(UIConfig.rollBtn1,"ANCHOR_CURSOR")
		UIConfig.tip:Hide()
		end)
	-- UI Reset Button
	UIConfig.resetBtn = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.resetBtn:SetPoint("BOTTOMLEFT",UIConfig.Bg,"BOTTOMLEFT", 20, 10);
	UIConfig.resetBtn:SetSize(80,20);
	UIConfig.resetBtn:SetText("Reset");
	UIConfig.resetBtn:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.resetBtn:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.resetBtn:SetScript("OnClick",function(self,arg1)
		ResetAddon()
	end)
	-- Duplicate Roll Button (for testing rolloffs)
	UIConfig.lootBtn = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.lootBtn:SetPoint("CENTER",UIConfig.resetBtn,"CENTER", 0, 30);
	UIConfig.lootBtn:SetSize(80,20);
	UIConfig.lootBtn:SetText("DupeRoll");
	UIConfig.lootBtn:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.lootBtn:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.lootBtn:SetScript("OnClick",function(self,arg1)
		UL_NumRollers = UL_NumRollers + 1
		UL_Roller[UL_NumRollers] = "Ugghsy"
		UL_Roll[UL_NumRollers] = UL_Roll[UL_NumRollers-1]
		
	end)
	UIConfig.lootBtn:Hide()
	-- Hide Button
	UIConfig.hideBtn1 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.hideBtn1:SetPoint("CENTER",UIConfig.resetBtn,"CENTER", 0, 30);
	UIConfig.hideBtn1:SetSize(80,20);
	UIConfig.hideBtn1:SetText("Hide");
	UIConfig.hideBtn1:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.hideBtn1:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.hideBtn1:SetScript("OnClick",function(self,arg1)
		UIConfig:Hide()
			UIConfig:Hide()
		end)
	-- Broadcast Instructions Button
	UIConfig.infoBtn1 = CreateFrame("Button", nil, UIConfig, "GameMenuButtonTemplate");
	UIConfig.infoBtn1:SetPoint("CENTER",UIConfig.hideBtn1,"CENTER", 0, 30);
	UIConfig.infoBtn1:SetSize(80,20);
	UIConfig.infoBtn1:SetText("Info");
	UIConfig.infoBtn1:SetNormalFontObject("GameFontNormalLarge");
	UIConfig.infoBtn1:SetHighlightFontObject("GameFontHighlightLarge");
	UIConfig.infoBtn1:SetScript("OnClick",function(self,arg1)
		BroadcastInstructions()
	end)
	-- UI Slider (not currently used)
	UIConfig.slider1 = CreateFrame("Slider", "DurationSlider", UIConfig, "OptionsSliderTemplate");
	UIConfig.slider1:SetPoint("BOTTOMRIGHT", UIConfig.Bg, "BOTTOMRIGHT", -20, 50);
	UIConfig.slider1:SetMinMaxValues(10,30);
	UIConfig.slider1:SetValue(20);
	UIConfig.slider1:SetValueStep(10);
	UIConfig.slider1:SetObeyStepOnDrag(true);
	getglobal(DurationSlider:GetName() .. 'Low'):SetText('10'); --Sets the left-side slider text (default is "Low").
	getglobal(DurationSlider:GetName() .. 'High'):SetText('30'); --Sets the right-side slider text (default is "High").
	getglobal(DurationSlider:GetName() .. 'Text'):SetText('Roll Duration:' .. UIConfig.slider1:GetValue());
	UIConfig.slider1:Hide()
	-- CheckButton
	
	UIConfig.checkBtn1 = CreateFrame("CheckButton", nil, UIConfig, "UICheckButtonTemplate");
	UIConfig.checkBtn1:SetPoint("LEFT", UIConfig.slider1, "LEFT", 00, -40);
	UIConfig.checkBtn1.text:SetText("Listen for Loot Trades");
	UIConfig.checkBtn1:SetChecked(UL_Enabled);
	UIConfig.checkBtn1:SetScript("OnClick",function(self)
		EnableToggle()
	end)
	-- ToolTip
	UIConfig.tip = CreateFrame("GAMETOOLTIP","$parentToolTip",nil,"GameTooltipTemplate")
	UIConfig.tip:SetOwner(WorldFrame,"ANCHOR_NONE")
	-- MiniMap Button Tool Top
	
	UIConfig:SetScript("OnEvent", function(self,event,...)
	if UL_DB == nil then UL_DBNew = {} end
	UL_ldbIcon:Register("UgghyLoot2",UL_MMB,UL_DB)
	
	
	end)
	
	
	UIConfig:RegisterEvent("PLAYER_LOGIN")
		
end
function HideUI()
	UIConfig:Hide()
end
function ShowUI()
	UIConfig:Show()
end
function WhisperReceivedEvent(event,msg,sender, ...)
	-- only offer rolls shown in raid/party chat if the user is a group leader or has assist in raid
	if UL_debug then print("Message Received!") end
	if UL_debug then print(msg) end
	if UL_debug then print(sender) end
	if UL_debug then print(...) end
	ProcessWhisper(msg,sender)
	
	
end
function AddLoot(sender,loot)
	if UL_debug then print("Doing Loot Add") end
	local AddedOK = 0
	for UL_UIloop = 1,8,1 do
		
		if UL_debug then print("------") end
		if UL_debug then print ("Loop# " .. UL_UIloop) end
		if UL_debug then print("SlotContent# " .. UL_UIslotText[UL_UIloop]) end
		if UL_debug then print("------") end
		if UL_UIslotText[UL_UIloop] == "" then
			if UL_debug then print("It was blank") end
			if UL_debug then print("Adding to slot" .. UL_UIloop) end
			UL_UIslotText[UL_UIloop] = loot
			UL_UIslotSender[UL_UIloop] = sender
			UL_UIslotState[UL_UIloop] = 1
			AddedOK = 1
			break
		end
	end
	if AddedOK == 1 then 
		UL_LootItems = UL_LootItems +1
		if UL_LootItems == 1 then SendChatMessage("UL2: " .. UL_LootItems .. " loot item to be rolled on.", "RAID") end
		if UL_LootItems > 1 then SendChatMessage("UL2: " .. UL_LootItems .. " loot items to be rolled on.", "RAID") end
		
		SendWhisper("Your item " .. loot .. " has been added to the Roll List ! Thanks!", sender)
		UpdateSlots()
	else
		SendWhisper("UL2: Sorry, Too many things in the queue.", sender)
		SendWhisper("UL2: Try again after a roll-off has been completed", sender)
		if UL_debug then print("UL2: Can't add new loot, full up") end
	end
end
function RemoveLoot(slot)
		-- Copy the current setup to temp variables
		if UL_debug then print("Doing Delete on slot " .. slot ) end
		local UL_tempslotText = {}
		local UL_tempslotSender = {}
		local UL_tempslotState = {}
		if UL_debug then print("********************") end
		for UL_UIloop = 1,8,1 do
			
			if UL_debug then print(UL_UIloop .. ":" .. UL_UIslotText[UL_UIloop]) end
		end
			if UL_debug then print("********************") end
		
		for UL_UIloop = 1, 8, 1 do
			UL_tempslotText[UL_UIloop] = UL_UIslotText[UL_UIloop]
			if UL_debug then print(UL_UIloop .. ":" .. UL_tempslotText[UL_UIloop] .. " - " .. UL_UIslotText[UL_UIloop]) end
			UL_tempslotSender[UL_UIloop] = UL_UIslotSender[UL_UIloop]
			if UL_debug then print(UL_UIloop .. ":" .. UL_tempslotSender[UL_UIloop] .. " " .. UL_UIslotSender[UL_UIloop]) end
			UL_tempslotState[UL_UIloop] = UL_UIslotState[UL_UIloop]
			if UL_debug then print(UL_UIloop .. ":" .. UL_tempslotState[UL_UIloop] .. " " .. UL_UIslotState[UL_UIloop]) end
		end
		-- Clear the originals
		SetInitialState()
		-- Copy the old stuff back, removing the deleted item
		local activeSlot = 1
		for UL_UIloop = 1,8,1 do
			if UL_debug then print(UL_tempslotText[UL_UIloop]) end
			if UL_debug then print("UIslotText:" .. UL_UIloop) end
			if UL_UIloop ~= slot then
				if UL_debug then print("Slot #" .. UL_UIloop .. "Adding :" .. UL_tempslotText[UL_UIloop]) end
				UL_UIslotText[activeSlot] = UL_tempslotText[UL_UIloop]
				UL_UIslotSender[activeSlot] = UL_tempslotSender[UL_UIloop]
				UL_UIslotState[activeSlot] = UL_tempslotState[UL_UIloop]
				if UL_debug then print("Slot #" .. activeSlot .. " now set to " .. UL_UIslotText[activeSlot]) end
				activeSlot = activeSlot + 1
				
			else
				if UL_debug then print("Skipping slot #" .. UL_UIloop) end
			end
		end
		for UL_UIloop = 1,8,1 do
			if UL_debug then print("********************") end
			if UL_debug then print(UL_UIloop .. ":" .. UL_UIslotText[UL_UIloop]) end
			if UL_debug then print("********************") end
			
		end
		UL_LootItems = UL_LootItems -1
		if UL_LootItems > 1 then 
			SendChatMessage("UL2: " .. UL_LootItems .. " loot items remaining to be rolled on.", "RAID")
		end
		if UL_LootItems == 1 then 
			SendChatMessage("UL2: " .. UL_LootItems .. " loot item remaining to be rolled on.", "RAID")
		end
		if UL_LootItems == 0 then 
			SendChatMessage("UL2: Loot Rolling complete. No remaining items.", "RAID")
		end
		UpdateSlots()
end
function EnableToggle()
	if (UL_Enabled) then
		UL_Enabled = false
	else
		if UnitInRaid("player") then 
			UL_Enabled = true
		else
			print("UL2: You need to be in a Raid group to enable.")
		end 
	end
	if (UL_Enabled) then
		print('UL2: UgghyLoot2 has been enabled.')
		UIConfig.checkBtn1:SetChecked(UL_Enabled)
		UIConfig:RegisterEvent("CHAT_MSG_WHISPER", "WhisperReceivedEvent")
		SetListenScript()
		UL_MMB.icon = "Interface\\Addons\\UgghyLoot2\\UL2logo_green"
		print(UL_MMB.iconCoords)
	else
		print('UL2: UgghyLoot2 has been disabled.')
		UIConfig.checkBtn1:SetChecked(UL_Enabled)
		UIConfig:UnregisterEvent("CHAT_MSG_WHISPER", "WhisperReceivedEvent")
		UIConfig:UnregisterEvent("CHAT_MSG_SYSTEM")
		UL_MMB.icon = "Interface\\Addons\\UgghyLoot2\\UL2logo_red"
	end
end
function ProcessWhisper(message, sender) 
  -- if the person whispered 'trade [item]' or '[item] trade', then add the item to the array so we can process it
  local _, _, whispereditem = string.find(message, 'trade (|.+|r)')
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, 'trade(|.+|r)')
  end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, 'Trade (|.+|r)')
	end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, 'Trade(|.+|r)')
  end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, 'TRADE (|.+|r)')
	end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, 'TRADE(|.+|r)')
  end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r) trade')
	end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r)trade')
  end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r) Trade')
	end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r)Trade')
  end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r) TRADE')
	end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r)TRADE')
  end
  if whispereditem == nil then
	 _, _, whispereditem = string.find(message, 'loot (|.+|r)')
  end
    if whispereditem == nil then
    _, _, whispereditem = string.find(message, 'loot(|.+|r)')
  end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, 'Loot (|.+|r)')
	end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, 'Loot(|.+|r)')
  end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, 'LOOT (|.+|r)')
	end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, 'LOOT(|.+|r)')
  end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r) loot')
	end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r)loot')
  end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r) Loot')
	end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r)Loot')
  end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r) LOOT')
	end
  if whispereditem == nil then
    _, _, whispereditem = string.find(message, '(|.+|r)LOOT')
  end
  
  if whispereditem ~= nil then
    AddLoot(sender,whispereditem)
	
  end


  end
function SendWhisper(message, person)
	SendChatMessage("UL2:" .. message, 'WHISPER', nil, person)
end
function SendDelayedWhisper(delay,message, person)
	C_Timer.After(delay, function()
		SendChatMessage("UL2:" .. message, 'WHISPER', nil, person)
		end
	)
end
function SendRollMessage(duration,item)
	local message = "Roll on " .. item .. " - You have " .. duration .. " seconds."
	SendChatMessage("UL2:" .. message, "RAID_WARNING")
end
function BroadcastInstructions()
	local playerName = UnitName("player")
	UL_Instructions = {}
	UL_Instructions[1] = "---------------------------------"
	UL_Instructions[2] = "  UgghyLoot2 Loot Helper  "
	UL_Instructions[3] = "---------------------------------"
	UL_Instructions[4] = " If you have loot to trade"
	UL_Instructions[5] = " send a whisper to " .. playerName
	UL_Instructions[6] = " in one of the following formats :"
	UL_Instructions[7] = " "
	UL_infolink = "|cff0070dd|Hitem:139749::::::::110:64::11:2:3386:3381:::|h[Cowl of Tirisgarde]|h|r"
	UL_Instructions[8] = "     trade " .. UL_infolink 
	UL_Instructions[9] = "     " .. UL_infolink .. " trade"
	UL_Instructions[10] = "    loot " .. UL_infolink 
	UL_Instructions[11] = "    " .. UL_infolink .. " loot"
	UL_Instructions[12] = " "
	UL_Instructions[13] = "---------------------------------"
	UL_Instructions[14] = " Your trade will be noted  "
	UL_Instructions[15] = " and can then be rolled on "
	UL_Instructions[16] = " when initated by " .. playerName
	UL_Instructions[17] = "----------------------------------"
	
	for i = 1,#UL_Instructions,1 do
		SendChatMessage("UL2:" .. UL_Instructions[i], "RAID")
	end
	
end
------------------
---- MainCode ----
------------------
SetUI()	-- Build the frame, buttons, loot slots and so on
SetInitialState() -- put all the initial values in place
UpdateSlots() -- Update all the slots and button visibility
HideUI()		-- Hide the UI until the user decides to show it.
print("UL2: UgghyLoot2 ver:" .. UL_version .. " loaded!")
print("UL2:Use '/ul2 toggle' to start listening for trades")
print("UL2:Use '/ul2 show'  to show the UI")